<?php
namespace Service\Calc\Strategy;
/**
*
* Interface to calculate
* planed, spend, Remaining
*/
class LeafHourCalcStrategy implements HourCalcStrategyInterface {
	/**
	*
	*/
	public function __construct(\Service\AppropriationInterface $appropriationService){
		$this->appropriationService = $appropriationService;
	}

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $task
     * @return mixed
     */
	public function planned($task){
		return $task->getPlanned();
	}

	public function spend($task){
		return $this->appropriationService->getAppropriationSpendTimeByTask($task);
	}

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $task
     * @return mixed
     */
	public function percentCompleted($task){
		return $task->getPercentCompleted();
	}

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calc\TaskInterface $task
     * @return float
     */
	public function remaining($task){
        if($task->isTask() && $task->getIsParent() == 'Y'){
            $task->setPlanned(0);
            $task->setPercentCompleted(0);
            return 0;
        }
		return ((100-$task->getPercentCompleted()) / 100) * $task->getPlanned();
	}
    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calc\TaskInterface $task
     * @return float
     */
	public function progress($task){
		if($task->getPlanned() == 0){
			return 0;
		}else{
			return (($task->getSpend()+$task->getRemaining())/$task->getPlanned())*100;				
		}
	}
}